//
// Controls.cpp : implementation file
//
//http://www.codeguru.com/cpp_mfc/varread.shtml

#include "stdafx.h"

#ifndef _INC_COMMCTRL
#include <commctrl.h>
#endif

//#include <heres.h>
#include <Controls.h>
#include "..\include\controls.h"

// ...................................................................
BEGIN_MESSAGE_MAP( CHEComboBox, CComboBox )
ON_WM_LBUTTONDOWN( )
ON_WM_MOUSEWHEEL( )
END_MESSAGE_MAP( )

LPCTSTR CHEComboBox::null_str= _T("");

void CHEComboBox::InsertItem( LPCOMBOBOXEX_ITEM pItem )
{
	pItem->item= itemsEx.size( );
	itemsEx.insert( *pItem );
	InsertString( (int)pItem->item, pItem->strText );
}

void CHEComboBox::SetHEStyles( long inStyles )
{
	styles= inStyles;
}

void CHEComboBox::InsertItemAt( LPCOMBOBOXEX_ITEM pItem )
{
	ItemsExIt it= itemsEx.find( *pItem );
	if( it == itemsEx.end( ) )
	{
		pItem->item= itemsEx.size( );
		itemsEx.insert( *pItem );
		InsertString( (int)pItem->item, NULL );
		return;
	}
	ItemsExRevIt rit( itemsEx.end( ) );
	ItemsExRevIt ritend( it );
	for( ; rit != ritend; )
	{
		//THIS IS Butt Ugly..... but it works
		COMBOBOXEX_ITEM tItem= *rit;
		long temp= (int)tItem.item;
		//TRACE( "%d\n", tItem.item );
		it= rit.base( );
		--it;
		++rit;
		itemsEx.erase( it );
		tItem.item= temp + 1;
		itemsEx.insert( tItem );
	}
	itemsEx.insert( *pItem );

	ResetContent( );
	for( it= itemsEx.begin( ); it != itemsEx.end( ); ++it )
	{
		InsertString( (int)it->item, NULL );
	}
}

DWORD_PTR CHEComboBox::GetItemDataEx( long pos )
{
	COMBOBOXEX_ITEM tItem;
	tItem.item= pos;
	ItemsExIt it= itemsEx.find( tItem );
	if( it != itemsEx.end( ) )
		return it->userData;
	else
		return 0;
}

//COMPAREITEMSTRUCT
int CHEComboBox::CompareItem( LPCOMPAREITEMSTRUCT lpCompareItemStruct )
{
	return 0;
}

void CHEComboBox::MeasureItem( LPMEASUREITEMSTRUCT lpMeasureItemStruct )
{
	lpMeasureItemStruct->itemHeight= 21;  //TODO
}

void CHEComboBox::DrawItem( LPDRAWITEMSTRUCT lpDrawItemStruct ) 
{
	if( lpDrawItemStruct->itemID == -1 || ! GetCount( ) )
		return;

	if( styles & HECOMBO_USECHECKS && ! pImgList )
	{
		pImgList= new CImageList;
		pImgList->Create( HE_IDB_CLV_CHECK, 16, 1, RGB( 255, 0, 0) );
	}
	ASSERT( lpDrawItemStruct->itemID < itemsEx.size( ) );
	COMBOBOXEX_ITEM cbItem;
	cbItem.item= lpDrawItemStruct->itemID;
	cbItem= *itemsEx.find( cbItem );
	CDC dc;
	dc.Attach( lpDrawItemStruct->hDC );

	COLORREF crOldTextColor= dc.GetTextColor( );
	COLORREF crOldBkColor= dc.GetBkColor( );

	if( ( lpDrawItemStruct->itemAction | ODA_SELECT )
		&& ( lpDrawItemStruct->itemState  & ODS_SELECTED ) )
	{
		dc.SetTextColor( ::GetSysColor( COLOR_HIGHLIGHTTEXT ) );
		dc.SetBkColor( ::GetSysColor( COLOR_HIGHLIGHT ) );
		dc.FillSolidRect( &lpDrawItemStruct->rcItem, ::GetSysColor( COLOR_HIGHLIGHT ) );
	}
	else
		dc.FillSolidRect( &lpDrawItemStruct->rcItem, crOldBkColor );

	CRect rect( lpDrawItemStruct->rcItem );
	rect.left+= cbItem.offset;
	rect.DeflateRect( 1, 0 );

	rect.left+=18 * cbItem.offset;
	HICON hIcon= NULL;

	//hIcon take priority
	if( cbItem.hIcon )
		hIcon= cbItem.hIcon;

	else if( pImgList )
		hIcon= pImgList->ExtractIcon( cbItem.iIcon );

	if( hIcon )
		DrawIconEx( dc.GetSafeHdc( ), rect.left, rect.top, hIcon, 0, 0, 0, NULL, DI_NORMAL );

	rect.left+= 18;
	dc.DrawText( cbItem.strText, -1, &rect, DT_LEFT | DT_SINGLELINE | DT_VCENTER );

	dc.SetTextColor( crOldTextColor );
	dc.SetBkColor( crOldBkColor );
	dc.Detach( );
}

BOOL CHEComboBox::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	return TRUE;
	return CComboBox::OnMouseWheel(nFlags, zDelta, pt);
}

BOOL CHEComboBox::PreTranslateMessage( MSG* pMsg )
{
	//TRACE( "CHEComboBox: %x\n", pMsg->message );

	return CComboBox::PreTranslateMessage( pMsg );
}

void CHEComboBox::PreSubclassWindow( )
{
	//pImgList= new CImageList;
	//pImgList->Create( HE_IDB_CLV_CHECK, 16, 1, RGB( 255, 0, 0) );

	CComboBox::PreSubclassWindow( );
}

//void CHEComboBox::OnNcLButtonDown(UINT nHitTest, CPoint point)
//{
//	// TODO: Add your message handler code here and/or call default
//
//	CComboBox::OnNcLButtonDown(nHitTest, point);
//}

void CHEComboBox::OnLButtonDown( UINT nFlags, CPoint point )
{
	TRACE( "lb down %d\n", point.x );
	// TODO: Add your message handler code here and/or call default

	CComboBox::OnLButtonDown( nFlags, point );
}

// ...............................................................................

IMPLEMENT_DYNAMIC( CDialogBarEx, CDialogBar )
BEGIN_MESSAGE_MAP( CDialogBarEx, CDialogBar )
	ON_WM_CTLCOLOR( )
END_MESSAGE_MAP( )

HBRUSH CDialogBarEx::OnCtlColor( CDC* pDC, CWnd* pWnd, UINT nCtlColor )
{
	HBRUSH hbr = CDialogBar::OnCtlColor( pDC, pWnd, nCtlColor );
	//TRACE( "CDialogBarEx::OnCtlColor: %d %d\n", nCtlColor, pWnd->GetDlgCtrlID( ) );

	//ON_NOTIFY( FDB_CTLCOLOR, {the ID of the dialog bar}, member )
	//FRMDLGBAR frm.hdr.idFrom is id of the child that needs color.
	//
	if( pWnd->GetSafeHwnd( ) == GetSafeHwnd( ) )
		return hbr;

	CFrameWnd* pFrame= dynamic_cast< CFrameWnd* >( GetParent( ) );
	if( ! pFrame ) //because it may or may not be docked
		pFrame= dynamic_cast< CFrameWnd* >( GetParent( )->GetParent( ) );

	if( pFrame )
	{
		FRMDLGBAR frm;
		frm.hdr.code= FDB_CTLCOLOR;

		CComboBox* pCombo= dynamic_cast<CComboBox*>( pWnd->GetParent( ) );

		frm.hdr.hwndFrom= GetSafeHwnd( );
		if( nCtlColor == 1 )
			frm.hdr.idFrom= pWnd->GetParent( )->GetDlgCtrlID( );//pCombo->GetDlgCtrlID( );
		else
			frm.hdr.idFrom= pWnd->GetDlgCtrlID( );

		//frm.hdr.idFrom= pWnd->GetParent( )->GetDlgCtrlID( );//pCombo->GetDlgCtrlID( );

		frm.nCtlColor= nCtlColor;
		frm.hbr= hbr;
		frm.pDC= pDC;
		pFrame->SendMessage( WM_NOTIFY, 0, (LPARAM)&frm );
		hbr= frm.hbr;
	}
	return hbr;
}

// .......................................................................
//Declared in heres.h, should be in global controls
IMPLEMENT_DYNCREATE( CStaticDialog, CDialog )

CStaticDialog::CStaticDialog( CWnd* pParent /*=NULL*/)
	: CDialog( CStaticDialog::IDD, pParent )
{
}

void CStaticDialog::SetStaticString( LPCTSTR inStr )
{
	cStatic.SetWindowText( inStr );
}

CStaticDialog::~CStaticDialog( )
{
}

void CStaticDialog::Create( )
{
	CDialog::Create( IDD_DIALOG_STATIC );
	ShowWindow( SW_NORMAL );
}

void CStaticDialog::DoDataExchange( CDataExchange* pDX )
{
	CDialog::DoDataExchange( pDX );
	DDX_Control( pDX, IDC_STATIC_TEXT, cStatic );
}

BOOL CStaticDialog::OnInitDialog( )
{
	return CDialog::OnInitDialog( );
}

BEGIN_MESSAGE_MAP( CStaticDialog, CDialog )
END_MESSAGE_MAP( )

// This is part of the Professional User Interface Suite library.
// Copyright (C) 2001-2004 FOSS Software, Inc.
// All rights reserved.
//
// http://www.prof-uis.com
// http://www.fossware.com
// mailto:foss@fossware.com

// Warranties and Disclaimers:
// THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND
// INCLUDING, BUT NOT LIMITED TO, WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT.o
// IN NO EVENT WILL FOSS SOFTWARE INC. BE LIABLE FOR ANY DIRECT,
// INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES,
// INCLUDING DAMAGES FOR LOSS OF PROFITS, LOSS OR INACCURACY OF DATA,
// INCURRED BY ANY PERSON FROM SUCH PERSON'S USAGE OF THIS SOFTWARE
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

// ExtStatusControlBar.cpp : implementation file
//

//#include "stdafx.h"
//
//#ifdef _DEBUG
//#define new DEBUG_NEW
//#undef THIS_FILE
//static char THIS_FILE[] = __FILE__;
//#endif

/////////////////////////////////////////////////////////////////////////////
// CExtStatusControlBar

CExtStatusControlBar::CExtStatusControlBar()
{
}

CExtStatusControlBar::~CExtStatusControlBar()
{
	for ( int i = 0; i < m_arrPaneControls.GetSize(); i++ ){
		if( m_arrPaneControls[i]->hWnd && ::IsWindow(m_arrPaneControls[i]->hWnd) ) {
			::ShowWindow(m_arrPaneControls[i]->hWnd, SW_HIDE); 
			if( m_arrPaneControls[i]->bAutoDestroy ) {
				::DestroyWindow(m_arrPaneControls[i]->hWnd);
			}
		}
		_STATUSBAR_PANE_CTRL_ *pPaneCtrl = m_arrPaneControls[i];
		if( pPaneCtrl )
			delete pPaneCtrl;
	}
}

BEGIN_MESSAGE_MAP(CExtStatusControlBar, CStatusBar)
	//{{AFX_MSG_MAP(CExtStatusControlBar)
	ON_WM_CREATE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CExtStatusControlBar message handlers
//////////////////////////////////////////////////////////////////////////

int CExtStatusControlBar::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if( CStatusBar::OnCreate(lpCreateStruct) == -1 )
		return -1;
	
	return 0;
}

//////////////////////////////////////////////////////////////////////////

LRESULT CExtStatusControlBar::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult =CStatusBar::WindowProc(message, wParam, lParam);
	if( message == WM_SIZE ){
		RepositionControls();
	}
	return lResult;
}

//////////////////////////////////////////////////////////////////////////

void CExtStatusControlBar::RepositionControls( )
{
	HDWP _hDWP = ::BeginDeferWindowPos( (int)m_arrPaneControls.GetSize() );
	
	CRect rcClient;
	GetClientRect(&rcClient);
	for (int i = 0; i < m_arrPaneControls.GetSize(); i++ )
	{
		int   iIndex  = CommandToIndex(m_arrPaneControls[i]->nID);
		HWND hWnd    = m_arrPaneControls[i]->hWnd;
		
		CRect rcPane;
		GetItemRect(iIndex, &rcPane);
		
		// CStatusBar::GetItemRect() sometimes returns invalid size 
		// of the last pane - we will re-compute it
		int cx = ::GetSystemMetrics( SM_CXEDGE );
		DWORD dwPaneStyle = GetPaneStyle( iIndex );
		if( iIndex == (m_nCount-1) )
		{
			if( (dwPaneStyle & SBPS_STRETCH ) == 0 )
			{
				UINT nID, nStyle;
				int  cxWidth;
				GetPaneInfo( iIndex, nID, nStyle, cxWidth );
				rcPane.right = rcPane.left + cxWidth + cx*3;
			} // if( (dwPaneStyle & SBPS_STRETCH ) == 0 )
			else
			{
				CRect rcClient;
				GetClientRect( &rcClient );
				rcPane.right = rcClient.right;
				if( (GetStyle() & SBARS_SIZEGRIP) == SBARS_SIZEGRIP )
				{
					int cxSmIcon = ::GetSystemMetrics( SM_CXSMICON );
					rcPane.right -= cxSmIcon + cx;
				} // if( (GetStyle() & SBARS_SIZEGRIP) == SBARS_SIZEGRIP )
			} // else from if( (dwPaneStyle & SBPS_STRETCH ) == 0 )
		} // if( iIndex == (m_nCount-1) )
		
		if ((GetPaneStyle (iIndex) & SBPS_NOBORDERS) == 0){
			rcPane.DeflateRect(cx,cx);
		}else{
			rcPane.DeflateRect(cx,1,cx,1);
		}
		
		if (hWnd && ::IsWindow(hWnd)){
			_hDWP = ::DeferWindowPos(
				_hDWP, 
				hWnd, 
				NULL, 
				rcPane.left,
				rcPane.top, 
				rcPane.Width(), 
				rcPane.Height(),
				SWP_NOZORDER|SWP_NOOWNERZORDER|SWP_SHOWWINDOW
				);

			::RedrawWindow(
				hWnd,
				NULL,
				NULL,
				RDW_INVALIDATE|RDW_UPDATENOW
				|RDW_ERASE|RDW_ERASENOW
				);
			
		} // if (hWnd && ::IsWindow(hWnd)){ 
	}
	
	VERIFY( ::EndDeferWindowPos( _hDWP ) );
};

//////////////////////////////////////////////////////////////////////////

BOOL CExtStatusControlBar::AddPane(
	 UINT nID,	// ID of the  pane
	 int nIndex	// index of the pane
	 )
{
	if (nIndex < 0 || nIndex > m_nCount){
		ASSERT(FALSE);
		return FALSE;
	}
	
	if (CommandToIndex(nID) != -1){
		ASSERT(FALSE);
		return FALSE;
	}
	
	CArray<_STATUSBAR_PANE_*,_STATUSBAR_PANE_*> arrPanesTmp;
	int iIndex = 0;
	for (iIndex = 0; iIndex < m_nCount+1; iIndex++)
	{
		_STATUSBAR_PANE_* pNewPane = new _STATUSBAR_PANE_;
		
		if (iIndex == nIndex){
			pNewPane->nID    = nID;
			pNewPane->nStyle = SBPS_NORMAL;
		}else{
			int idx = iIndex;
			if (iIndex > nIndex) idx--;
			
			_STATUSBAR_PANE_* pOldPane  = GetPanePtr(idx);
			pNewPane->cxText  = pOldPane->cxText;
			pNewPane->nFlags  = pOldPane->nFlags;
			pNewPane->nID     = pOldPane->nID;
			pNewPane->nStyle  = pOldPane->nStyle;
			pNewPane->strText = pOldPane->strText;
		}
		arrPanesTmp.Add(pNewPane);
	}
	
	INT_PTR nPanesCount = arrPanesTmp.GetSize();
	UINT* lpIDArray = new UINT[ nPanesCount ];
	for (iIndex = 0; iIndex < nPanesCount; iIndex++) {
		lpIDArray[iIndex] = arrPanesTmp[iIndex]->nID;
	}
	
	// set the indicators 
	SetIndicators( lpIDArray, (int)nPanesCount );
	// free memory
	for (iIndex = 0; iIndex < nPanesCount; iIndex++){
		_STATUSBAR_PANE_* pPane = arrPanesTmp[iIndex];
		if (iIndex != nIndex)
			PaneInfoSet(iIndex, pPane);
		if(pPane) 
			delete pPane;
	}
	
	arrPanesTmp.RemoveAll();
	if(lpIDArray) 
		delete []lpIDArray;
	
	RepositionControls();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////

BOOL CExtStatusControlBar::RemovePane(
	UINT nID	// ID of the pane
	)
{
	if ( CommandToIndex(nID) == -1 || m_nCount == 1 ){
		ASSERT(FALSE);
		return FALSE;
	}
	
	CArray<_STATUSBAR_PANE_*,_STATUSBAR_PANE_*> arrPanesTmp;
	int nIndex;
	for (nIndex = 0; nIndex < m_nCount; nIndex++)
	{
		_STATUSBAR_PANE_* pOldPane = GetPanePtr(nIndex);
		
		if (pOldPane->nID == nID)
			continue;
		
		_STATUSBAR_PANE_* pNewPane = new _STATUSBAR_PANE_;
		
		pNewPane->cxText  = pOldPane->cxText;
		pNewPane->nFlags  = pOldPane->nFlags;
		pNewPane->nID     = pOldPane->nID;
		pNewPane->nStyle  = pOldPane->nStyle;
		pNewPane->strText = pOldPane->strText;
		arrPanesTmp.Add(pNewPane);
	}
	
	UINT* lpIDArray = new UINT[arrPanesTmp.GetSize()];
	for (nIndex = 0; nIndex < arrPanesTmp.GetSize(); nIndex++) {
		lpIDArray[nIndex] = arrPanesTmp[nIndex]->nID;
	}
	
	// set the indicators
	SetIndicators(lpIDArray, (int)arrPanesTmp.GetSize());
	// free memory
	for (nIndex = 0; nIndex < arrPanesTmp.GetSize(); nIndex++){
		_STATUSBAR_PANE_* pPane = arrPanesTmp[nIndex];
		PaneInfoSet(nIndex, pPane);
		if(pPane) 
			delete pPane;
	}
	
	for ( int i = 0; i < m_arrPaneControls.GetSize(); i++ ){
		if (m_arrPaneControls[i]->nID == nID){
			if( m_arrPaneControls[i]->hWnd && ::IsWindow(m_arrPaneControls[i]->hWnd) ) {
				::ShowWindow(m_arrPaneControls[i]->hWnd, SW_HIDE); 
				if( m_arrPaneControls[i]->bAutoDestroy ) {
					::DestroyWindow(m_arrPaneControls[i]->hWnd);
				}
			}
			_STATUSBAR_PANE_CTRL_ *pPaneCtrl = m_arrPaneControls[i];
			if( pPaneCtrl )
				delete pPaneCtrl;
			m_arrPaneControls.RemoveAt(i);
			break;
		}
	}
	
	arrPanesTmp.RemoveAll();
	if(lpIDArray) 
		delete []lpIDArray;
	
	RepositionControls();
	
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////

BOOL CExtStatusControlBar::AddPaneControl(HWND hWnd, UINT nID, BOOL bAutoDestroy)
{
	if (CommandToIndex (nID) == -1) {
		return FALSE;
	}
	
	_STATUSBAR_PANE_CTRL_* pPaneCtrl = new _STATUSBAR_PANE_CTRL_;
	pPaneCtrl->nID         = nID;
	pPaneCtrl->hWnd        = hWnd;
	pPaneCtrl->bAutoDestroy = bAutoDestroy;
	
	m_arrPaneControls.Add(pPaneCtrl);

	RepositionControls();
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////

BOOL CExtStatusControlBar::PaneInfoGet(int nIndex, _STATUSBAR_PANE_* pPane)
{
	if( nIndex < m_nCount  && nIndex >= 0 )
	{
		GetPaneInfo( nIndex,  pPane->nID, pPane->nStyle, pPane->cxText );
		CString strPaneText;
		GetPaneText( nIndex , strPaneText );
		pPane->strText = LPCTSTR(strPaneText);
		return TRUE;
	}
	return FALSE;
}

//////////////////////////////////////////////////////////////////////////

BOOL CExtStatusControlBar::PaneInfoSet(int nIndex, _STATUSBAR_PANE_* pPane)
{
	if( nIndex < m_nCount  && nIndex >= 0 ){
		SetPaneInfo( nIndex, pPane->nID, pPane->nStyle, pPane->cxText );
		SetPaneText( nIndex, LPCTSTR( pPane->strText) );
		return TRUE;
	}
	return FALSE;
}
