// mfc_diskioView.h : interface of the Cmfc_diskioView class
//
#pragma once

class Cmfc_diskioView : public CEditView
{
protected: // create from serialization only
	Cmfc_diskioView( );
	DECLARE_DYNCREATE( Cmfc_diskioView )

// Attributes
public:
	virtual ~Cmfc_diskioView( );

	Cmfc_diskioDoc* GetDocument( ) const;

	CDialogBarEx	barDisk;
	//
	CEdit			cBarEditSector;
	CComboBox		cBarComboDrives;

	CFont			font;

	//MBR				mbr;
	HEDriveInfoSet	set;
	pHEDriveInfo	pCurDrive;
	BYTE			sector[ 11512 ];
	long			curSector;
	DWORD			partition0;

	void SetViewSectorData( BYTE* inBytes );

public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();

protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
DECLARE_MESSAGE_MAP( )
	afx_msg void OnDBSectorChange( );
	afx_msg void OnPaint( );
	afx_msg void OnCbnSelchangeDbDrives( );
};

#ifndef _DEBUG  // debug version in mfc_diskioView.cpp
inline Cmfc_diskioDoc* Cmfc_diskioView::GetDocument() const
   { return reinterpret_cast<Cmfc_diskioDoc*>(m_pDocument); }
#endif

